package de.dwslab.lecture.wdi.rdf;


import org.apache.jena.query.Query;
import org.apache.jena.query.QueryFactory;

import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QuerySolution;
import org.apache.jena.query.ResultSet;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.vocabulary.DCTerms;
import org.apache.jena.vocabulary.RDFS;




public class WDI_20200_RG2_Solution10 {

	public static void main(String[] args) {

		// create RDF model
		Model model = ModelFactory.createDefaultModel();
		// fill the model with the data from the file
		model.read("mondial-3.0-europe-countries.rdf");
		// the sparql query to select all German speaking countries
		String queryString = "SELECT ?country ?label WHERE {?country <"
				+ RDFS.label
				+ "> ?label . ?country <"
				+ DCTerms.language
				+ "> ?language . ?language <" + RDFS.label + "> ?languageName . FILTER(?languageName=\"German\")}";
		// create the query
		Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model);
		// execute the query
		ResultSet results = qe.execSelect();
		// parse the results
		while (results.hasNext()) {
			QuerySolution sol = results.next();
			System.out.println(sol.get("label").toString() + "\t"
					+ sol.get("country").toString());
		}
	}

}
